/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatabricksDashboardsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards#dashboard_name_contains DataDatabricksDashboards#dashboard_name_contains}
    */
    readonly dashboardNameContains?: string;
}
export interface DataDatabricksDashboardsDashboards {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards#display_name DataDatabricksDashboards#display_name}
    */
    readonly displayName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards#serialized_dashboard DataDatabricksDashboards#serialized_dashboard}
    */
    readonly serializedDashboard?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards#warehouse_id DataDatabricksDashboards#warehouse_id}
    */
    readonly warehouseId?: string;
}
export declare function dataDatabricksDashboardsDashboardsToTerraform(struct?: DataDatabricksDashboardsDashboards): any;
export declare function dataDatabricksDashboardsDashboardsToHclTerraform(struct?: DataDatabricksDashboardsDashboards): any;
export declare class DataDatabricksDashboardsDashboardsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksDashboardsDashboards | undefined;
    set internalValue(value: DataDatabricksDashboardsDashboards | undefined);
    get createTime(): string;
    get dashboardId(): string;
    private _displayName?;
    get displayName(): string;
    set displayName(value: string);
    resetDisplayName(): void;
    get displayNameInput(): string | undefined;
    get etag(): string;
    get lifecycleState(): string;
    get parentPath(): string;
    get path(): string;
    private _serializedDashboard?;
    get serializedDashboard(): string;
    set serializedDashboard(value: string);
    resetSerializedDashboard(): void;
    get serializedDashboardInput(): string | undefined;
    get updateTime(): string;
    private _warehouseId?;
    get warehouseId(): string;
    set warehouseId(value: string);
    resetWarehouseId(): void;
    get warehouseIdInput(): string | undefined;
}
export declare class DataDatabricksDashboardsDashboardsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksDashboardsDashboards[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksDashboardsDashboardsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards databricks_dashboards}
*/
export declare class DataDatabricksDashboards extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "databricks_dashboards";
    /**
    * Generates CDKTF code for importing a DataDatabricksDashboards resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksDashboards to import
    * @param importFromId The id of the existing DataDatabricksDashboards that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksDashboards to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.68.0/docs/data-sources/dashboards databricks_dashboards} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksDashboardsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksDashboardsConfig);
    private _dashboardNameContains?;
    get dashboardNameContains(): string;
    set dashboardNameContains(value: string);
    resetDashboardNameContains(): void;
    get dashboardNameContainsInput(): string | undefined;
    private _dashboards;
    get dashboards(): DataDatabricksDashboardsDashboardsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
